# GeoProver | Version 1.3a | Jan 20 2003
# Author: H.-G. Graebe, Univ. Leipzig, Germany
# http://www.informatik.uni-leipzig.de/~graebe

# GeoProver interface

geoprover[Point]:=proc() `geoprover/Point`(args) end:
geoprover[altitude]:=proc() `geoprover/altitude`(args) end:
geoprover[angle_sum]:=proc() `geoprover/angle_sum`(args) end:
geoprover[centroid]:=proc() `geoprover/centroid`(args) end:
geoprover[circle_center]:=proc() `geoprover/circle_center`(args) end:
geoprover[circle_slider]:=proc() `geoprover/circle_slider`(args) end:
geoprover[circle_sqradius]:=proc() `geoprover/circle_sqradius`(args) end:
geoprover[circumcenter]:=proc() `geoprover/circumcenter`(args) end:
geoprover[csym_point]:=proc() `geoprover/csym_point`(args) end:
geoprover[eq_angle]:=proc() `geoprover/eq_angle`(args) end:
geoprover[eq_dist]:=proc() `geoprover/eq_dist`(args) end:
geoprover[fixedpoint]:=proc() `geoprover/fixedpoint`(args) end:
geoprover[intersection_point]:=proc() `geoprover/intersection_point`(args) end:
geoprover[is_cc_tangent]:=proc() `geoprover/is_cc_tangent`(args) end:
geoprover[is_cl_tangent]:=proc() `geoprover/is_cl_tangent`(args) end:
geoprover[is_collinear]:=proc() `geoprover/is_collinear`(args) end:
geoprover[is_concurrent]:=proc() `geoprover/is_concurrent`(args) end:
geoprover[is_concyclic]:=proc() `geoprover/is_concyclic`(args) end:
geoprover[is_equal]:=proc() `geoprover/is_equal`(args) end:
geoprover[is_orthogonal]:=proc() `geoprover/is_orthogonal`(args) end:
geoprover[is_parallel]:=proc() `geoprover/is_parallel`(args) end:
geoprover[l2_angle]:=proc() `geoprover/l2_angle`(args) end:
geoprover[line_slider]:=proc() `geoprover/line_slider`(args) end:
geoprover[median]:=proc() `geoprover/median`(args) end:
geoprover[midpoint]:=proc() `geoprover/midpoint`(args) end:
geoprover[on_bisector]:=proc() `geoprover/on_bisector`(args) end:
geoprover[on_circle]:=proc() `geoprover/on_circle`(args) end:
geoprover[on_line]:=proc() `geoprover/on_line`(args) end:
geoprover[ortho_line]:=proc() `geoprover/ortho_line`(args) end:
geoprover[orthocenter]:=proc() `geoprover/orthocenter`(args) end:
geoprover[other_cc_point]:=proc() `geoprover/other_cc_point`(args) end:
geoprover[other_cl_point]:=proc() `geoprover/other_cl_point`(args) end:
geoprover[other_incenter]:=proc() `geoprover/other_incenter`(args) end:
geoprover[p3_angle]:=proc() `geoprover/p3_angle`(args) end:
geoprover[p3_circle]:=proc() `geoprover/p3_circle`(args) end:
geoprover[p9_center]:=proc() `geoprover/p9_center`(args) end:
geoprover[p9_circle]:=proc() `geoprover/p9_circle`(args) end:
geoprover[p_bisector]:=proc() `geoprover/p_bisector`(args) end:
geoprover[pappus_line]:=proc() `geoprover/pappus_line`(args) end:
geoprover[par_line]:=proc() `geoprover/par_line`(args) end:
geoprover[par_point]:=proc() `geoprover/par_point`(args) end:
geoprover[pc_circle]:=proc() `geoprover/pc_circle`(args) end:
geoprover[pedalpoint]:=proc() `geoprover/pedalpoint`(args) end:
geoprover[pp_line]:=proc() `geoprover/pp_line`(args) end:
geoprover[radical_axis]:=proc() `geoprover/radical_axis`(args) end:
geoprover[rotate]:=proc() `geoprover/rotate`(args) end:
geoprover[sqrdist]:=proc() `geoprover/sqrdist`(args) end:
geoprover[sqrdist_pl]:=proc() `geoprover/sqrdist_pl`(args) end:
geoprover[sym_line]:=proc() `geoprover/sym_line`(args) end:
geoprover[sym_point]:=proc() `geoprover/sym_point`(args) end:
geoprover[triangle_area]:=proc() `geoprover/triangle_area`(args) end:
geoprover[varpoint]:=proc() `geoprover/varpoint`(args) end:
geoprover[clear_ndg]:=proc() `geoprover/clear_ndg`(args) end:
geoprover[print_ndg]:=proc() `geoprover/print_ndg`(args) end:
geoprover[add_ndg]:=proc() `geoprover/add_ndg`(args) end:
geoprover[geo_plot]:=proc() `geoprover/geo_plot`(args) end:

# GeoProver inline code Version 1.3a
# 17 Jan 2003: contains also geo_plot code

# ============= Handling non degeneracy conditions ===============

`geoprover/clear_ndg`:=proc() global `geoprover/ndg_list`; 
  `geoprover/ndg_list`:=NULL end; 

`geoprover/clear_ndg`():  # Initialization 

`geoprover/print_ndg`:=proc() global `geoprover/ndg_list`;
  print([`geoprover/ndg_list`]) end;

`geoprover/add_ndg`:=proc(d) global `geoprover/ndg_list`; 
  if not member(d,[`geoprover/ndg_list`]) then
	`geoprover/ndg_list`:=d,`geoprover/ndg_list` fi 
  end;

# ============= some algebraic manipulations ===============

`geoprover/reduce_coords`:=proc(u)
  local p,l,g,i;
  p:=part(u,1); l:=denom(p); g:=numer(p);
  for i from 2 to nops(u) do 
	p:=part(u,i); l:=lcm(l,denom(p)); g:=gcd(g,numer(p)) od;
  `geoprover/add_ndg`(g);
  map(x->normal(x*l/g),u); 
  end;

# ================= elementary geometric constructions ===============

# Data structures:
# 
# 	Point A  :== [a1,a2]       <=> A=(a1,a2)
# 	Line  a  :== [a1,a2,a3]    <=> a1*x+a2*y+a3 = 0
#	Circle c :== [c0,c1,c2,c3] <=> c0*(x^2+y^2)+c1*x+c2*y+c3 = 0

`type/Point`:=list;
`type/Line`:=list;
`type/Circle`:=list;
`type/Scalar`:=anything;
`type/Boolean`:=anything;

`geoprover/is_equal`:=proc(a,b) normal(a-b) end;

part:=proc(a,b) op(b,a) end;

`geoprover/Point`:=proc(a,b) [normal(a),normal(b)] end;
`geoprover/Line`:=proc(a,b,c) 
  `geoprover/reduce_coords`([normal(a),normal(b),normal(c)]) end;

`geoprover/par_point`:=proc(a::Point,b::Point,c::Point)
  `geoprover/Point`(c[1]-b[1]+a[1], c[2]-b[2]+a[2]) end;

`geoprover/pp_line`:=proc(a::Point,b::Point)
  `geoprover/Line`(part(b,2)-part(a,2),part(a,1)-part(b,1),
	part(a,2)*part(b,1)-part(a,1)*part(b,2)) end; 

`geoprover/intersection_point`:=proc(a::Line,b::Line)
   local d,d1,d2;
   d:=normal(part(a,1)*part(b,2)-part(b,1)*part(a,2));
   d1:=part(a,3)*part(b,2)-part(b,3)*part(a,2);
   d2:=part(a,1)*part(b,3)-part(b,1)*part(a,3);
   if d=0 then ERROR("Lines are parallel") fi;
   `geoprover/add_ndg`(numer(d));
   `geoprover/Point`(-d1/d,-d2/d);
   end;

`geoprover/ortho_line`:=proc(p::Point,a::Line)
  local u,v; u:=part(a,1); v:=part(a,2);
  `geoprover/Line`(v,-u,u*part(p,2)-v*part(p,1));
  end;

`geoprover/par_line`:=proc(P::Point,a::Line)
  `geoprover/Line`(part(a,1),part(a,2),
	-(part(a,1)*part(P,1)+part(a,2) *part(P,2))) end;

`geoprover/varpoint`:=proc(b::Point,a::Point,l)
  `geoprover/Point`(l*part(a,1)+(1-l)*part(b,1),
	l*part(a,2)+(1-l)*part(b,2)) end;

`geoprover/line_slider`:=proc(a::Line,u)
  local p,d;
  if part(a,2)=0 then 
	p:=`geoprover/Point`(-part(a,3)/part(a,1),u); d:=part(a,1); 
  else 	
	p:=`geoprover/Point`(u,-(part(a,3)+part(a,1)*u)/part(a,2));
	d:=part(a,2); 
  fi;
  `geoprover/add_ndg`(numer(d));
  p;
  end;

`geoprover/sqrdist`:=proc(a::Point,b::Point)
  normal((part(b,1)-part(a,1))^2+(part(b,2)-part(a,2))^2) end;

`geoprover/is_collinear`:=proc(a::Point,b::Point,c::Point)
linalg[det](linalg[matrix](
	[[part(a,1),part(a,2),1],
	[part(b,1),part(b,2),1],
	[part(c,1),part(c,2),1]])) end;

`geoprover/is_concurrent`:=proc(a::Line,b::Line,c::Line)
linalg[det](linalg[matrix](
	[[part(a,1),part(a,2),part(a,3)],
	[part(b,1),part(b,2),part(b,3)],
	[part(c,1),part(c,2),part(c,3)]])) end;

`geoprover/is_parallel`:=proc(a::Line,b::Line)
  normal(part(a,1)*part(b,2)-part(b,1)*part(a,2)) end;

`geoprover/is_orthogonal`:=proc(a::Line,b::Line)
  normal(part(a,1)*part(b,1)+part(a,2)*part(b,2)) end;

`geoprover/on_line`:=proc(p::Point,a::Line)
  normal(part(p,1)*part(a,1)+part(p,2)*part(a,2)+part(a,3)) end;

`geoprover/eq_dist`:=proc(a::Point,b::Point,c::Point,d::Point)
  normal(`geoprover/sqrdist`(a,b)-`geoprover/sqrdist`(c,d)) end;

# ===================== angles ================ 

`geoprover/l2_angle`:=proc(a::Line,b::Line)
  local d; d:=normal(part(a,1)*part(b,1)+part(a,2)*part(b,2)); 
  `geoprover/add_ndg`(numer(d));
  normal((part(a,2)*part(b,1)-part(b,2)*part(a,1))/d);
  end;

`geoprover/angle_sum`:=proc(a,b)
  local d; d:=normal(1-a*b); `geoprover/add_ndg`(numer(d)); 
  normal((a+b)/d);
  end;

`geoprover/eq_angle`:=
proc(a::Point,b::Point,c::Point,d::Point,e::Point,f::Point)
  normal(`geoprover/p3_angle`(a,b,c)-`geoprover/p3_angle`(d,e,f)) 
end;

`geoprover/on_bisector`:=proc(P::Point,A::Point,B::Point,C::Point)
  local a1,a2,b1,b2,c1,c2,p1,p2;
	a1:=part(A,1); a2:=part(A,2);
	b1:=part(B,1); b2:=part(B,2);
	c1:=part(C,1); c2:=part(C,2);
	p1:=part(P,1); p2:=part(P,2);

    normal( normal( - a1*b2 + a1*p2 + a2*b1 - a2*p1 - b1*p2 +
    b2*p1)* normal( b1**2 - b1*c1 - b1*p1 + b2**2 - b2*c2 - b2*p2
    + c1*p1 + c2*p2) - normal(a1*b1 - a1*p1 + a2*b2 - a2*p2 -
    b1**2 + b1*p1 - b2**2 + b2*p2) * normal(b1*c2 - b1*p2 - b2*c1
    + b2*p1 + c1*p2 - c2*p1)); 
    
    end;

`geoprover/sym_line`:=proc(a::Line,l::Line)
  local a1,a2,a3,l1,l2,l3,u;
  a1:=part(a,1); a2:=part(a,2); a3:=part(a,3); 
  l1:=part(l,1); l2:=part(l,2); l3:=part(l,3); 
  u:=normal(l1^2 - l2^2);
  `geoprover/Line`(- a1*u - 2*a2*l1*l2, - 2*a1*l1*l2 + a2*u, 
		- 2*(a1*l1 + a2*l2)*l3 + a3*(l1^2 + l2^2));
  end;

`geoprover/rotate` := proc(C::Point, A::Point, angle)
  `geoprover/Point`(
    C[1]+(A[1]-C[1])*cos(angle*Pi)-(A[2]-C[2])*sin(angle*Pi),
    C[2]+(A[1]-C[1])*sin(angle*Pi)+(A[2]-C[2])*cos(angle*Pi)) 
  end:

# ===================== circles ================ 

`geoprover/circle_slider`:=proc(M::Point,A::Point,u)
  local d,a1,a2,m1,m2; 
  a1:=part(A,1); a2:=part(A,2); m1:=part(M,1); m2:=part(M,2);
  d:=normal(u^2+1); `geoprover/add_ndg`(numer(d));
  `geoprover/Point`((a1*(u^2-1) + 2*m1 + 2*(m2-a2)*u)/d, 
	 (a2 + 2*(m1-a1)*u + (2*m2-a2)*u^2)/d);
  end;

`geoprover/Circle`:=proc(c1,c2,c3,c4)
  `geoprover/reduce_coords`([normal(c1),normal(c2),normal(c3),normal(c4)]) 
end;

`geoprover/pc_circle`:=proc(M::Point,A::Point) 
  `geoprover/Circle`(1, -2*part(M,1), -2*part(M,2), 
	part(A,1)*(2*part(M,1)-part(A,1)) +
	    part(A,2)*(2*part(M,2)-part(A,2))) end;

`geoprover/circle_center`:=proc(c::Circle)
  `geoprover/add_ndg`(numer(part(c,1)));
  `geoprover/Point`(-part(c,2)/2/part(c,1) ,-part(c,3)/(2*part(c,1)));
  end;

`geoprover/circle_sqradius`:=proc(c::Circle)
  `geoprover/add_ndg`(numer(part(c,1)));
  normal(((part(c,2)^2+part(c,3)^2) - 4*part(c,4)*part(c,1)) / 
	(2*part(c,1))^2);
  end;

`geoprover/p3_circle`:=proc(A::Point,B::Point,C::Point)
  local a1,a2,a3,b1,b2,b3,c1,c2,c3;
  a1:=part(A,1); a2:=part(A,2); a3:=normal(a1^2+a2^2);
  b1:=part(B,1); b2:=part(B,2); b3:=normal(b1^2+b2^2);
  c1:=part(C,1); c2:=part(C,2); c3:=normal(c1^2+c2^2);
  `geoprover/Circle`(a1*(b2-c2) + (a2-b2)*c1 + b1*(c2-a2),
    a3*(c2-b2) + (a2-c2)*b3 + (b2-a2)*c3,
    a3*(b1-c1) + (c1-a1)*b3 + (a1-b1)*c3,
    a3*(b2*c1-b1*c2) + (a1*c2-a2*c1)*b3 + (a2*b1-a1*b2)*c3)
  end;

`geoprover/on_circle`:=proc(P::Point,c::Circle)
  local p1,p2; p1:=part(P,1); p2:=part(P,2);
  normal(part(c,1)*(p1^2+p2^2)+part(c,2)*p1+part(c,3)*p2+part(c,4));
  end;

`geoprover/other_cl_point`:=proc(P::Point,c::Circle,l::Line)
  local c1,c2,c3,l1,l2,d,d1,p1,p2;
  if `geoprover/on_line`(P,l) <> 0 then 
     ERROR( "Point not on the line") 
  elif `geoprover/on_circle`(P,c) <> 0 then 
	ERROR( "Point not on the circle")
  else 
  c1:=part(c,1); c2:=part(c,2); c3:=part(c,3); 
  l1:=part(l,1); l2:=part(l,2); p1:=part(P,1); p2:=part(P,2);
  d:=normal(c1*(l1^2 + l2^2)); `geoprover/add_ndg`(numer(d)); 
  d1:=normal(c1*(l1^2-l2^2));
  `geoprover/Point`((d1*p1+((2*c1*p2 + c3)*l1-c2*l2)*l2)/d, 
	(- d1*p2+((2*c1*p1 + c2)*l2-c3*l1)*l1)/d);
  fi end;

`geoprover/radical_axis`:=proc(c1::Circle,c2::Circle)
  `geoprover/Line`(seq(normal(part(c1,1)*part(c2,i)
	-part(c1,i)*part(c2,1)), i=2..4 )); 
  end;

`geoprover/other_cc_point`:=proc(P::Point,c1::Circle,c2::Circle)
  `geoprover/other_cl_point`(P,c1,`geoprover/radical_axis`(c1,c2));
  end;

`geoprover/is_cl_tangent`:=proc(c::Circle,l::Line)
  local c1,c2,c3,c4,l1,l2,l3;
  c1:=part(c,1); c2:=part(c,2); c3:=part(c,3); c4:=part(c,4); 
  l1:=part(l,1); l2:=part(l,2); l3:=part(l,3); 
  normal(4*c1*( (- c1*l3 + c2*l1 + c3*l2)*l3 - c4*(l1^2 + l2^2))  
	+ (c2*l2 - c3*l1)^2); 
  end;

`geoprover/is_cc_tangent`:=proc(c::Circle,d::Circle)
  local c1,c2,c3,c4,d1,d2,d3,d4;
  c1:=part(c,1); c2:=part(c,2); c3:=part(c,3); c4:=part(c,4); 
  d1:=part(d,1); d2:=part(d,2); d3:=part(d,3); d4:=part(d,4); 
  normal(4*(c1*d4-c4*d1)^2 - (c2*d3-c3*d2)^2 
	- 4*(c1*d4+c4*d1)*(c2*d2+c3*d3) + 4*c1*c4*(d2^2 + d3^2) 
	+ 4*(c2^2 + c3^2)*d1*d4) ;
  end;

##### Implementation of (undocumented) geo_plot #####

`geoprover/geo_plot`:=proc()		
  # args[1] is a list of _specified_ geometric objects to be plotted. 
  # args[2] is a range "x=a..b"
  # args[3] is an optional color entry "color=<color>"
  local p1,p2,u,v,c; 
  u:=args[1]; v:=args[2]; 
  if not (type(v,equation) and type(rhs(v),range)) then 
	ERROR("second argument must be <var> = <a> .. <b>") fi;
  if nargs<3 then c:=(color=black) else 
      c:=args[3]; if not (type(c,equation) and lhs(c)='color') then  
	  ERROR("third argument must be color = <color>") fi;
      fi;
  p1:=map(geo_plot1,u,v,c);	
	# a list of PLOTs with local color entries 
  `plots/display`(p1);
  end;

geo_plot1:=proc(p,rg,c) local u,c1,c2; 
  # plot a single object with color c
  if nops(p)=2			# p is a Point
	then u:=geo_plot_point(p,c)
  elif nops(p)=3		# p is a Line
	then u:=geo_plot_line(p,rg,c)
  elif part(p,1)=0		# p is a degenerated Circle
	then u:=geo_plot_line([op(2..4,p)],rg,c)
  else u:=geo_plot_circle(p,c) fi; 
  c1:=select(x->op(0,x)='COLOUR',[op(u)]);
  c2:=select(x->op(0,x)<>'COLOUR',[op(2..nops(u),u)]);
  PLOT(CURVES(op(1,op(1,u)),op(c1)),op(c2),VIEW(rhs(rg),rhs(rg)))
end;

geo_plot_point:=proc(p,c) local t; 
  plot([op(1,p)*t,op(2,p)*t,t=1..1],c) end;

geo_plot_line:=proc(p,range,c) local t; t:=op(1,range);
  if part(p,2)=0 then plot([-part(p,3)/part(p,1),t,range],c) 
  else plot([t,-(part(p,1)*t+part(p,3))/part(p,2),range],c) fi end;

geo_plot_circle:=proc(p,c) local t,M,r; 
  M:=`geoprover/circle_center`(p); 
  r:=sqrt(`geoprover/circle_sqradius`(p));
  plot([op(1,M)+r*sin(Pi*t/100.),op(2,M)+r*cos(Pi*t/100.),t=-100..100],c) 
  end; 



# GeoProver code generated from database 

`geoprover/altitude`:=proc(A_::Point,B_::Point,C_::Point)
	`geoprover/ortho_line`(A_,`geoprover/pp_line`(B_,C_)) end:
`geoprover/centroid`:=proc(A_::Point,B_::Point,C_::Point)
	`geoprover/intersection_point`(`geoprover/median`(A_,B_,C_),`geoprover/median`(B_,C_,A_)) end:
`geoprover/circumcenter`:=proc(A_::Point,B_::Point,C_::Point)
	`geoprover/intersection_point`(`geoprover/p_bisector`(A_,B_), `geoprover/p_bisector`(B_,C_)) end:
`geoprover/csym_point`:=proc(P_::Point,Q_::Point)
	`geoprover/varpoint`(Q_,P_,-1) end:
`geoprover/fixedpoint`:=proc(A_::Point,B_::Point,u_::Scalar)
	`geoprover/varpoint`(A_,B_,u_) end:
`geoprover/is_concyclic`:=proc(A_::Point,B_::Point,C_::Point,D_::Point)
	`geoprover/on_circle`(D_,`geoprover/p3_circle`(A_,B_,C_)) end:
`geoprover/median`:=proc(A_::Point,B_::Point,C_::Point)
	`geoprover/pp_line`(A_,`geoprover/midpoint`(B_,C_)) end:
`geoprover/midpoint`:=proc(A_::Point,B_::Point)
	`geoprover/fixedpoint`(A_,B_,1/2) end:
`geoprover/orthocenter`:=proc(A_::Point,B_::Point,C_::Point)
	`geoprover/intersection_point`(`geoprover/altitude`(A_,B_,C_),`geoprover/altitude`(B_,C_,A_)) end:
`geoprover/other_incenter`:=proc(M_::Point,A_::Point,B_::Point)
	`geoprover/intersection_point`(`geoprover/ortho_line`(A_,`geoprover/pp_line`(M_,A_)),
`geoprover/ortho_line`(B_,`geoprover/pp_line`(M_,B_))) end:
`geoprover/p3_angle`:=proc(A_::Point,B_::Point,C_::Point)
	`geoprover/l2_angle`(`geoprover/pp_line`(B_,A_),`geoprover/pp_line`(B_,C_)) end:
`geoprover/p9_center`:=proc(A_::Point,B_::Point,C_::Point)
	`geoprover/circle_center`(`geoprover/p9_circle`(A_,B_,C_)) end:
`geoprover/p9_circle`:=proc(A_::Point,B_::Point,C_::Point)
	`geoprover/p3_circle`(`geoprover/midpoint`(A_,B_),`geoprover/midpoint`(A_,C_),`geoprover/midpoint`(B_,C_)) end:
`geoprover/p_bisector`:=proc(B_::Point,C_::Point)
	`geoprover/ortho_line`(`geoprover/midpoint`(B_,C_),`geoprover/pp_line`(B_,C_)) end:
`geoprover/pappus_line`:=proc(A_::Point,B_::Point,C_::Point,D_::Point,E_::Point,F_::Point)
	`geoprover/pp_line`(`geoprover/intersection_point`(`geoprover/pp_line`(A_,E_),`geoprover/pp_line`(B_,D_)),
	`geoprover/intersection_point`(`geoprover/pp_line`(A_,F_),`geoprover/pp_line`(C_,D_))) end:
`geoprover/pedalpoint`:=proc(P_::Point,a_::Line)
	`geoprover/intersection_point`(`geoprover/ortho_line`(P_,a_),a_) end:
`geoprover/sqrdist_pl`:=proc(A_::Point,l_::Line)
	`geoprover/sqrdist`(A_,`geoprover/pedalpoint`(A_,l_)) end:
`geoprover/sym_point`:=proc(P_::Point,l_::Line)
	`geoprover/fixedpoint`(P_,`geoprover/pedalpoint`(P_,l_),2) end:
`geoprover/triangle_area`:=proc(A_::Point,B_::Point,C_::Point)
	1/2*`geoprover/is_collinear`(A_,B_,C_) end:
# GeoProver code end.
